/*$Id: file-net.cc,v 1.58 2003/05/30 08:12:40 al Exp $ -*- C++ -*-
 */
#include "net.h"
/*--------------------------------------------------------------------------*/
namespace Netlist {
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
void make_header(std::ostream& out, const Overhead& o)
{
  out << "*[File Name] " << o.file_name()  << '\n'
      << "*[File Rev]  " << o.file_rev()   << '\n'
      << "*[Date]      " << o.date()       << '\n';
    //<< "*[Source]    " << o.source()     << '\n'
    //<< "*[Notes]     " << o.notes()      << '\n'
    //<< "*[Disclaimer]" << o.disclaimer() << '\n'
    //<< "*[Copyright] " << o.copyright()  << '\n';
}
/*--------------------------------------------------------------------------*/
void make_body(std::ostream& out, const Ibis_File& file,
	       const std::string& state, const std::string& prefix)
{
  out << "*[IBIS Ver]  " << file.ibis_ver()   << '\n'
      << ".option namednodes\n";
  make_header(	  out, file.overhead());
  make_components(out, file.components(), prefix, state);
  make_ebd(	  out, file.boards(),	  prefix, state);
  make_models(	  out, file.models(),	  prefix, state);
  make_instances( out, file.instances(),  prefix, state);
  out << ".option nonamednodes\n";
}
/*--------------------------------------------------------------------------*/
void make_file(const Ibis_File& file, const std::string& filename,
	       const std::string& state, const std::string& prefix)
{
  {if (filename == "-") {
    make_body(std::cout, file, state, prefix);
  }else{
    std::ofstream out(filename.c_str());
    if (!out) {
      untested();
      os_error(file.name());
    }
    make_body(out, file, state, prefix);
  }}
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
